## rust-blake3 1.8.1

=== c/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9 FATAL_ERROR)

# respect C_EXTENSIONS OFF without explicitly setting C_STANDARD
if (POLICY CMP0128)
  cmake_policy(SET CMP0128 NEW)
endif()
# mark_as_advanced does not implicitly create UNINITIALIZED cache entries
if (POLICY CMP0102)
  cmake_policy(SET CMP0102 NEW)
endif()

project(libblake3
  VERSION 1.8.1
  DESCRIPTION "BLAKE3 C implementation"
  LANGUAGES C CXX ASM
)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

option(BLAKE3_USE_TBB "Enable oneTBB parallelism" OFF)
option(BLAKE3_FETCH_TBB "Allow fetching oneTBB from GitHub if not found on system" OFF)

include(CTest)
include(FeatureSummary)
include(GNUInstallDirs)

add_subdirectory(dependencies)

# architecture lists for which to enable assembly / SIMD sources
set(BLAKE3_AMD64_NAMES amd64 AMD64 x86_64)
set(BLAKE3_X86_NAMES i686 x86 X86)
set(BLAKE3_ARMv8_NAMES aarch64 AArch64 arm64 ARM64 armv8 armv8a)
# default SIMD compiler flag configuration (can be overriden by toolchains or CLI)
if(MSVC)
  set(BLAKE3_CFLAGS_SSE2 "/arch:SSE2" CACHE STRING "the compiler flags to enable SSE2")
  # MSVC has no dedicated sse4.1 flag (see https://learn.microsoft.com/en-us/cpp/build/reference/arch-x86?view=msvc-170)
  set(BLAKE3_CFLAGS_SSE4.1 "/arch:AVX" CACHE STRING "the compiler flags to enable SSE4.1")
  set(BLAKE3_CFLAGS_AVX2 "/arch:AVX2" CACHE STRING "the compiler flags to enable AVX2")
  set(BLAKE3_CFLAGS_AVX512 "/arch:AVX512" CACHE STRING "the compiler flags to enable AVX512")

  set(BLAKE3_AMD64_ASM_SOURCES
    blake3_avx2_x86-64_windows_msvc.asm
    blake3_avx512_x86-64_windows_msvc.asm
    blake3_sse2_x86-64_windows_msvc.asm
    blake3_sse41_x86-64_windows_msvc.asm
  )

elseif(CMAKE_C_COMPILER_ID STREQUAL "GNU"
       OR CMAKE_C_COMPILER_ID STREQUAL "Clang"
       OR CMAKE_C_COMPILER_ID STREQUAL "AppleClang")
  set(BLAKE3_CFLAGS_SSE2 "-msse2" CACHE STRING "the compiler flags to enable SSE2")
  set(BLAKE3_CFLAGS_SSE4.1 "-msse4.1" CACHE STRING "the compiler flags to enable SSE4.1")
  set(BLAKE3_CFLAGS_AVX2 "-mavx2" CACHE STRING "the compiler flags to enable AVX2")
  set(BLAKE3_CFLAGS_AVX512 "-mavx512f -mavx512vl" CACHE STRING "the compiler flags to enable AVX512")

  if (WIN32 OR CYGWIN)
    set(BLAKE3_AMD64_ASM_SOURCES
      blake3_avx2_x86-64_windows_gnu.S
      blake3_avx512_x86-64_windows_gnu.S
      blake3_sse2_x86-64_windows_gnu.S
      blake3_sse41_x86-64_windows_gnu.S
    )

  elseif(UNIX)
    set(BLAKE3_AMD64_ASM_SOURCES
      blake3_avx2_x86-64_unix.S
      blake3_avx512_x86-64_unix.S
      blake3_sse2_x86-64_unix.S
      blake3_sse41_x86-64_unix.S
    )
  endif()

  if (CMAKE_SYSTEM_PROCESSOR IN_LIST BLAKE3_ARMv8_NAMES
      AND NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
    # 32-bit ARMv8 needs NEON to be enabled explicitly
    set(BLAKE3_CFLAGS_NEON "-mfpu=neon" CACHE STRING "the compiler flags to enable NEON")
  endif()
endif()

mark_as_advanced(BLAKE3_CFLAGS_SSE2 BLAKE3_CFLAGS_SSE4.1 BLAKE3_CFLAGS_AVX2 BLAKE3_CFLAGS_AVX512 BLAKE3_CFLAGS_NEON)
mark_as_advanced(BLAKE3_AMD64_ASM_SOURCES)

message(STATUS "BLAKE3 SIMD configuration: ${CMAKE_C_COMPILER_ARCHITECTURE_ID}")
if(MSVC AND DEFINED CMAKE_C_COMPILER_ARCHITECTURE_ID)
  if(CMAKE_C_COMPILER_ARCHITECTURE_ID MATCHES "[Xx]86")
    set(BLAKE3_SIMD_TYPE "x86-intrinsics" CACHE STRING "the SIMD acceleration type to use")

  elseif(CMAKE_C_COMPILER_ARCHITECTURE_ID MATCHES "[Xx]64")
    set(BLAKE3_SIMD_TYPE "amd64-asm" CACHE STRING "the SIMD acceleration type to use")

  elseif(CMAKE_C_COMPILER_ARCHITECTURE_ID MATCHES "[Aa][Rr][Mm]64")
    set(BLAKE3_SIMD_TYPE "neon-intrinsics" CACHE STRING "the SIMD acceleration type to use")

  else()
    set(BLAKE3_SIMD_TYPE "none" CACHE STRING "the SIMD acceleration type to use")
  endif()

elseif(CMAKE_SYSTEM_PROCESSOR IN_LIST BLAKE3_AMD64_NAMES)
  set(BLAKE3_SIMD_TYPE "amd64-asm" CACHE STRING "the SIMD acceleration type to use")

elseif(CMAKE_SYSTEM_PROCESSOR IN_LIST BLAKE3_X86_NAMES
       AND DEFINED BLAKE3_CFLAGS_SSE2
       AND DEFINED BLAKE3_CFLAGS_SSE4.1
       AND DEFINED BLAKE3_CFLAGS_AVX2
       AND DEFINED BLAKE3_CFLAGS_AVX512)
  set(BLAKE3_SIMD_TYPE "x86-intrinsics" CACHE STRING "the SIMD acceleration type to use")

elseif((CMAKE_SYSTEM_PROCESSOR IN_LIST BLAKE3_ARMv8_NAMES
          OR ANDROID_ABI STREQUAL "armeabi-v7a"
          OR BLAKE3_USE_NEON_INTRINSICS)
        AND (DEFINED BLAKE3_CFLAGS_NEON
          OR CMAKE_SIZEOF_VOID_P EQUAL 8))
  set(BLAKE3_SIMD_TYPE "neon-intrinsics" CACHE STRING "the SIMD acceleration type to use")

else()
  set(BLAKE3_SIMD_TYPE "none" CACHE STRING "the SIMD acceleration type to use")
endif()

mark_as_advanced(BLAKE3_SIMD_TYPE)

# library target
add_library(blake3
  blake3.c
  blake3_dispatch.c
  blake3_portable.c
)
add_library(BLAKE3::blake3 ALIAS blake3)

# library configuration
set(BLAKE3_PKGCONFIG_CFLAGS)
if (BUILD_SHARED_LIBS)
  target_compile_definitions(blake3
    PUBLIC BLAKE3_DLL
    PRIVATE BLAKE3_DLL_EXPORTS
  )
  list(APPEND BLAKE3_PKGCONFIG_CFLAGS -DBLAKE3_DLL)
endif()
target_include_directories(blake3 PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)
set_target_properties(blake3 PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION 0
  C_VISIBILITY_PRESET hidden
  C_EXTENSIONS OFF
)
target_compile_features(blake3 PUBLIC c_std_99)
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.12)
  target_compile_features(blake3 PUBLIC cxx_std_20)
  # else: add it further below through `BLAKE3_CMAKE_CXXFLAGS_*`
endif()

# ensure C_EXTENSIONS OFF is respected without overriding CMAKE_C_STANDARD
# which may be set by the user or toolchain file
if (NOT POLICY CMP0128 AND NOT DEFINED CMAKE_C_STANDARD)
  set_target_properties(blake3 PROPERTIES C_STANDARD 99)
endif()

# optional SIMD sources
if(BLAKE3_SIMD_TYPE STREQUAL "amd64-asm")
  if (NOT DEFINED BLAKE3_AMD64_ASM_SOURCES)
    message(FATAL_ERROR "BLAKE3_SIMD_TYPE is set to 'amd64-asm' but no assembly sources are available for the target architecture.")
  endif()
  set(BLAKE3_SIMD_AMD64_ASM ON)

  if(MSVC)
    enable_language(ASM_MASM)
  endif()

  target_sources(blake3 PRIVATE ${BLAKE3_AMD64_ASM_SOURCES})

elseif(BLAKE3_SIMD_TYPE STREQUAL "x86-intrinsics")
  if (NOT DEFINED BLAKE3_CFLAGS_SSE2
      OR NOT DEFINED BLAKE3_CFLAGS_SSE4.1
      OR NOT DEFINED BLAKE3_CFLAGS_AVX2
      OR NOT DEFINED BLAKE3_CFLAGS_AVX512)
    message(FATAL_ERROR "BLAKE3_SIMD_TYPE is set to 'x86-intrinsics' but no compiler flags are available for the target architecture.")
  endif()
  set(BLAKE3_SIMD_X86_INTRINSICS ON)

  target_sources(blake3 PRIVATE
    blake3_avx2.c
    blake3_avx512.c
    blake3_sse2.c
    blake3_sse41.c
  )
  set_source_files_properties(blake3_avx2.c PROPERTIES COMPILE_FLAGS "${BLAKE3_CFLAGS_AVX2}")
  set_source_files_properties(blake3_avx512.c PROPERTIES COMPILE_FLAGS "${BLAKE3_CFLAGS_AVX512}")
  set_source_files_properties(blake3_sse2.c PROPERTIES COMPILE_FLAGS "${BLAKE3_CFLAGS_SSE2}")
  set_source_files_properties(blake3_sse41.c PROPERTIES COMPILE_FLAGS "${BLAKE3_CFLAGS_SSE4.1}")

elseif(BLAKE3_SIMD_TYPE STREQUAL "neon-intrinsics")
  set(BLAKE3_SIMD_NEON_INTRINSICS ON)

  target_sources(blake3 PRIVATE
    blake3_neon.c
  )
  target_compile_definitions(blake3 PRIVATE
    BLAKE3_USE_NEON=1
  )

  if (DEFINED BLAKE3_CFLAGS_NEON)
    set_source_files_properties(blake3_neon.c PROPERTIES COMPILE_FLAGS "${BLAKE3_CFLAGS_NEON}")
  endif()

elseif(BLAKE3_SIMD_TYPE STREQUAL "none")
  target_compile_definitions(blake3 PRIVATE
    BLAKE3_USE_NEON=0
    BLAKE3_NO_SSE2
    BLAKE3_NO_SSE41
    BLAKE3_NO_AVX2
    BLAKE3_NO_AVX512
  )

else()
  message(FATAL_ERROR "BLAKE3_SIMD_TYPE is set to an unknown value: '${BLAKE3_SIMD_TYPE}'")
endif()

if(BLAKE3_USE_TBB)
  find_package(TBB 2021.11.0 QUIET)
  if(NOT TBB_FOUND AND NOT TARGET TBB::tbb)
    message(WARNING
      "oneTBB not found; disabling BLAKE3_USE_TBB\n"
      "Enable BLAKE3_FETCH_TBB to automatically fetch and build oneTBB"
    )
    set(BLAKE3_USE_TBB OFF)
  else()
    target_sources(blake3
      PRIVATE
        blake3_tbb.cpp)
    target_link_libraries(blake3
      PUBLIC
        # Make shared TBB a transitive dependency. The consuming program is technically not required
        # to link TBB in order for libblake3 to function but we do this in order to prevent the
        # possibility of multiple separate TBB runtimes being linked into a final program in case
        # the consuming program also happens to already use TBB.
        TBB::tbb)
    target_compile_definitions(blake3
      PUBLIC
        BLAKE3_USE_TBB)
  endif()
  list(APPEND PKG_CONFIG_REQUIRES "tbb >= ${TBB_VERSION}")
  list(APPEND BLAKE3_PKGCONFIG_CFLAGS -DBLAKE3_USE_TBB)
endif()

if(BLAKE3_USE_TBB)
  # Define some scratch variables for building appropriate flags per compiler
  if(CMAKE_VERSION VERSION_LESS 3.12)
    set(APPEND BLAKE3_CXX_STANDARD_FLAGS_GNU -std=c++20)
    set(APPEND BLAKE3_CXX_STANDARD_FLAGS_MSVC /std:c++20)
  endif()
  set(BLAKE3_CXXFLAGS_GNU "-fno-exceptions;-fno-rtti;${BLAKE3_CXX_STANDARD_FLAGS_GNU}" CACHE STRING "C++ flags used for compiling private BLAKE3 library components with GNU-like compiler frontends.")
  set(BLAKE3_CXXFLAGS_MSVC "/EHs-c-;/GR-;${BLAKE3_CXX_STANDARD_FLAGS_MSVC}" CACHE STRING "C++ flags used for compiling private BLAKE3 library components with MSVC-like compiler frontends.")
  # Get the C++ compiler name without extension
  get_filename_component(BLAKE3_CMAKE_CXX_COMPILER_NAME "${CMAKE_CXX_COMPILER}" NAME_WE)
  # Strip any trailing versioning from the C++ compiler name
  string(REGEX MATCH "^(clang\\+\\+|clang-cl)" BLAKE3_CMAKE_CXX_COMPILER_NAME "${BLAKE3_CMAKE_CXX_COMPILER_NAME}")

  # TODO: Simplify with CMAKE_CXX_COMPILER_FRONTEND_VARIANT once min CMake version is 3.14.
  if(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
    target_compile_options(blake3 PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${BLAKE3_CXXFLAGS_GNU}>)
  elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    if(BLAKE3_CMAKE_CXX_COMPILER_NAME STREQUAL "clang++")
      target_compile_options(blake3 PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${BLAKE3_CXXFLAGS_GNU}>)
    elseif(BLAKE3_CMAKE_CXX_COMPILER_NAME STREQUAL "clang-cl")
      target_compile_options(blake3 PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${BLAKE3_CXXFLAGS_MSVC}>)
    endif()
  elseif(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(blake3 PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${BLAKE3_CXXFLAGS_GNU}>)
  elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(blake3 PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${BLAKE3_CXXFLAGS_MSVC}>)
  endif()

  # Undefine scratch variables
  unset(BLAKE3_CXX_STANDARD_FLAGS_GNU)
  unset(BLAKE3_CXX_STANDARD_FLAGS_MSVC)
  unset(BLAKE3_CMAKE_CXX_COMPILER_NAME)
  unset(BLAKE3_CXXFLAGS_GNU)
  unset(BLAKE3_CXXFLAGS_MSVC)
endif()

# cmake install support
install(FILES blake3.h DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
install(TARGETS blake3 EXPORT blake3-targets
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
)
install(EXPORT blake3-targets
  NAMESPACE BLAKE3::
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/blake3"
)

include(CMakePackageConfigHelpers)
configure_package_config_file(blake3-config.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/blake3-config.cmake"

    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/blake3"
)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/blake3-config-version.cmake"
    VERSION ${libblake3_VERSION}
    COMPATIBILITY SameMajorVersion
)
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/blake3-config.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/blake3-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/blake3"
)

# Function for joining paths known from most languages
#
# SPDX-License-Identifier: (MIT OR CC0-1.0)
# Copyright 2020 Jan Tojnar
# https://github.com/jtojnar/cmake-snips
#
# Modelled after Python’s os.path.join
# https://docs.python.org/3.7/library/os.path.html#os.path.join

=== c/dependencies/tbb/CMakeLists.txt ===
if(WIN32 AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  message(FATAL_ERROR "BLAKE3_USE_TBB requires building with Clang or MSVC on Windows")
  set(BLAKE3_USE_TBB OFF)
endif()

find_package(TBB 2021.11.0 QUIET)

if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.11)
  include(FetchContent)

  if(NOT TBB_FOUND AND BLAKE3_FETCH_TBB)
    set(CMAKE_C_STANDARD 99)
    set(CMAKE_C_EXTENSIONS OFF)

    set(CMAKE_CXX_STANDARD 20)
    set(CMAKE_CXX_EXTENSIONS ON)

    option(TBB_TEST OFF "")
    option(TBBMALLOC_BUILD OFF "")

    mark_as_advanced(TBB_TEST)
    mark_as_advanced(TBBMALLOC_BUILD)

    FetchContent_Declare(
      TBB
      GIT_REPOSITORY https://github.com/uxlfoundation/oneTBB
      GIT_TAG 0c0ff192a2304e114bc9e6557582dfba101360ff # v2022.0.0
      GIT_SHALLOW TRUE
    )

    FetchContent_MakeAvailable(TBB)
  endif()
endif()

=== debian/changelog ===
rust-blake3 (1.8.1-1) unstable; urgency=medium

  * Team upload.
  * Package blake3 1.8.1 from crates.io using debcargo 2.7.8
  * Relax rand to 0.8

 -- Blair Noctis <ncts@debian.org>  Wed, 09 Apr 2025 19:52:18 +0000

=== debian/control ===
Source: rust-blake3
Section: rust
Priority: optional
Build-Depends: debhelper-compat (= 13),
 dh-sequence-cargo
Build-Depends-Arch: cargo:native <!nocheck>,
 rustc:native <!nocheck>,
 libstd-rust-dev <!nocheck>,
 librust-arrayref-0.3+default-dev (>= 0.3.5-~~) <!nocheck>,
 librust-arrayvec-0.7-dev (>= 0.7.4-~~) <!nocheck>,
 librust-cc-1+default-dev (>= 1.1.12-~~) <!nocheck>,
 librust-cfg-if-1+default-dev <!nocheck>,
 librust-constant-time-eq-0.3-dev (>= 0.3.1-~~) <!nocheck>
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 karthek <mail@karthek.com>
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/blake3]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/blake3
Homepage: https://github.com/BLAKE3-team/BLAKE3
X-Cargo-Crate: blake3
Rules-Requires-Root: no

Package: librust-blake3-dev
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librust-arrayref-0.3+default-dev (>= 0.3.5-~~),
 librust-arrayvec-0.7+zeroize-dev (>= 0.7.4-~~),
 librust-arrayvec-0.7-dev (>= 0.7.4-~~),
 librust-cc-1+default-dev (>= 1.1.12-~~),
 librust-cfg-if-1+default-dev,
 librust-constant-time-eq-0.3-dev (>= 0.3.1-~~),
 librust-digest-0.10+default-dev (>= 0.10.1-~~),
 librust-digest-0.10+mac-dev (>= 0.10.1-~~),
 librust-memmap2-0.9+default-dev,
 librust-rayon-core-1+default-dev (>= 1.12.1-~~),
 librust-serde-1+derive-dev,
 librust-zeroize-1-dev
Provides:
 librust-blake3+default-dev (= ${binary:Version}),
 librust-blake3+digest-dev (= ${binary:Version}),
 librust-blake3+mmap-dev (= ${binary:Version}),
 librust-blake3+neon-dev (= ${binary:Version}),
 librust-blake3+no-avx2-dev (= ${binary:Version}),
 librust-blake3+no-avx512-dev (= ${binary:Version}),
 librust-blake3+no-neon-dev (= ${binary:Version}),
 librust-blake3+no-sse2-dev (= ${binary:Version}),
 librust-blake3+no-sse41-dev (= ${binary:Version}),
 librust-blake3+prefer-intrinsics-dev (= ${binary:Version}),
 librust-blake3+pure-dev (= ${binary:Version}),
 librust-blake3+rayon-dev (= ${binary:Version}),
 librust-blake3+serde-dev (= ${binary:Version}),
 librust-blake3+std-dev (= ${binary:Version}),
 librust-blake3+traits-preview-dev (= ${binary:Version}),
 librust-blake3+wasm32-simd-dev (= ${binary:Version}),
 librust-blake3+zeroize-dev (= ${binary:Version}),
 librust-blake3-1-dev (= ${binary:Version}),
 librust-blake3-1+default-dev (= ${binary:Version}),
 librust-blake3-1+digest-dev (= ${binary:Version}),
 librust-blake3-1+mmap-dev (= ${binary:Version}),
 librust-blake3-1+neon-dev (= ${binary:Version}),
 librust-blake3-1+no-avx2-dev (= ${binary:Version}),
 librust-blake3-1+no-avx512-dev (= ${binary:Version}),
 librust-blake3-1+no-neon-dev (= ${binary:Version}),
 librust-blake3-1+no-sse2-dev (= ${binary:Version}),
 librust-blake3-1+no-sse41-dev (= ${binary:Version}),
 librust-blake3-1+prefer-intrinsics-dev (= ${binary:Version}),
 librust-blake3-1+pure-dev (= ${binary:Version}),
 librust-blake3-1+rayon-dev (= ${binary:Version}),
 librust-blake3-1+serde-dev (= ${binary:Version}),
 librust-blake3-1+std-dev (= ${binary:Version}),
 librust-blake3-1+traits-preview-dev (= ${binary:Version}),
 librust-blake3-1+wasm32-simd-dev (= ${binary:Version}),
 librust-blake3-1+zeroize-dev (= ${binary:Version}),
 librust-blake3-1.8-dev (= ${binary:Version}),
 librust-blake3-1.8+default-dev (= ${binary:Version}),
 librust-blake3-1.8+digest-dev (= ${binary:Version}),
 librust-blake3-1.8+mmap-dev (= ${binary:Version}),
 librust-blake3-1.8+neon-dev (= ${binary:Version}),
 librust-blake3-1.8+no-avx2-dev (= ${binary:Version}),
 librust-blake3-1.8+no-avx512-dev (= ${binary:Version}),
 librust-blake3-1.8+no-neon-dev (= ${binary:Version}),
 librust-blake3-1.8+no-sse2-dev (= ${binary:Version}),
 librust-blake3-1.8+no-sse41-dev (= ${binary:Version}),
 librust-blake3-1.8+prefer-intrinsics-dev (= ${binary:Version}),
 librust-blake3-1.8+pure-dev (= ${binary:Version}),
 librust-blake3-1.8+rayon-dev (= ${binary:Version}),
 librust-blake3-1.8+serde-dev (= ${binary:Version}),
 librust-blake3-1.8+std-dev (= ${binary:Version}),
 librust-blake3-1.8+traits-preview-dev (= ${binary:Version}),
 librust-blake3-1.8+wasm32-simd-dev (= ${binary:Version}),
 librust-blake3-1.8+zeroize-dev (= ${binary:Version}),
 librust-blake3-1.8.1-dev (= ${binary:Version}),
 librust-blake3-1.8.1+default-dev (= ${binary:Version}),
 librust-blake3-1.8.1+digest-dev (= ${binary:Version}),
 librust-blake3-1.8.1+mmap-dev (= ${binary:Version}),
 librust-blake3-1.8.1+neon-dev (= ${binary:Version}),
 librust-blake3-1.8.1+no-avx2-dev (= ${binary:Version}),
 librust-blake3-1.8.1+no-avx512-dev (= ${binary:Version}),
 librust-blake3-1.8.1+no-neon-dev (= ${binary:Version}),
 librust-blake3-1.8.1+no-sse2-dev (= ${binary:Version}),
 librust-blake3-1.8.1+no-sse41-dev (= ${binary:Version}),
 librust-blake3-1.8.1+prefer-intrinsics-dev (= ${binary:Version}),
 librust-blake3-1.8.1+pure-dev (= ${binary:Version}),
 librust-blake3-1.8.1+rayon-dev (= ${binary:Version}),
 librust-blake3-1.8.1+serde-dev (= ${binary:Version}),
 librust-blake3-1.8.1+std-dev (= ${binary:Version}),
 librust-blake3-1.8.1+traits-preview-dev (= ${binary:Version}),
 librust-blake3-1.8.1+wasm32-simd-dev (= ${binary:Version}),
 librust-blake3-1.8.1+zeroize-dev (= ${binary:Version})
Description: BLAKE3 hash function - Rust source code
 Source code for Debianized Rust crate "blake3"

=== debian/tests/control ===
Test-Command: /usr/share/cargo/bin/cargo-auto-test blake3 1.8.1 --all-targets --all-features
Features: test-name=rust-blake3:@
Depends: dh-cargo (>= 31), rustc, librust-ciborium-0.2+default-dev (>= 0.2.2-~~), librust-hex-0.4+default-dev (>= 0.4.2-~~), librust-hmac-0.12+default-dev, librust-page-size-0.6+default-dev, librust-rand-0.8+default-dev, librust-rand-chacha-0.3+default-dev (>= 0.3.1-~~), librust-serde-json-1+default-dev (>= 1.0.107-~~), librust-tempfile-3+default-dev (>= 3.8.0-~~), @
Restrictions: allow-stderr, skip-not-installable, flaky

Test-Command: /usr/share/cargo/bin/cargo-auto-test blake3 1.8.1 --all-targets
Features: test-name=librust-blake3-dev:default
Depends: dh-cargo (>= 31), rustc, librust-ciborium-0.2+default-dev (>= 0.2.2-~~), librust-hex-0.4+default-dev (>= 0.4.2-~~), librust-hmac-0.12+default-dev, librust-page-size-0.6+default-dev, librust-rand-0.8+default-dev, librust-rand-chacha-0.3+default-dev (>= 0.3.1-~~), librust-serde-json-1+default-dev (>= 1.0.107-~~), librust-tempfile-3+default-dev (>= 3.8.0-~~), @
Restrictions: allow-stderr, skip-not-installable

Test-Command: /usr/share/cargo/bin/cargo-auto-test blake3 1.8.1 --all-targets --no-default-features --features digest
Features: test-name=librust-blake3-dev:digest
Depends: dh-cargo (>= 31), rustc, librust-ciborium-0.2+default-dev (>= 0.2.2-~~), librust-hex-0.4+default-dev (>= 0.4.2-~~), librust-hmac-0.12+default-dev, librust-page-size-0.6+default-dev, librust-rand-0.8+default-dev, librust-rand-chacha-0.3+default-dev (>= 0.3.1-~~), librust-serde-json-1+default-dev (>= 1.0.107-~~), librust-tempfile-3+default-dev (>= 3.8.0-~~), @
Restrictions: allow-stderr, skip-not-installable

Test-Command: /usr/share/cargo/bin/cargo-auto-test blake3 1.8.1 --all-targets --no-default-features --features mmap
Features: test-name=librust-blake3-dev:mmap
Depends: dh-cargo (>= 31), rustc, librust-ciborium-0.2+default-dev (>= 0.2.2-~~), librust-hex-0.4+default-dev (>= 0.4.2-~~), librust-hmac-0.12+default-dev, librust-page-size-0.6+default-dev, librust-rand-0.8+default-dev, librust-rand-chacha-0.3+default-dev (>= 0.3.1-~~), librust-serde-json-1+default-dev (>= 1.0.107-~~), librust-tempfile-3+default-dev (>= 3.8.0-~~), @
Restrictions: allow-stderr, skip-not-installable

Test-Command: /usr/share/cargo/bin/cargo-auto-test blake3 1.8.1 --all-targets --no-default-features --features neon
Features: test-name=librust-blake3-dev:neon
Depends: dh-cargo (>= 31), rustc, librust-ciborium-0.2+default-dev (>= 0.2.2-~~), librust-hex-0.4+default-dev (>= 0.4.2-~~), librust-hmac-0.12+default-dev, librust-page-size-0.6+default-dev, librust-rand-0.8+default-dev, librust-rand-chacha-0.3+default-dev (>= 0.3.1-~~), librust-serde-json-1+default-dev (>= 1.0.107-~~), librust-tempfile-3+default-dev (>= 3.8.0-~~), @
Restrictions: allow-stderr, skip-not-installable, flaky

Test-Command: /usr/share/cargo/bin/cargo-auto-test blake3 1.8.1 --all-targets --no-default-features --features no_avx2

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/(.*)\/download/blake3-$1\.tar\.gz/g,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\.?\d*)$/$1~$2/ \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=crates.io/blake3 .*/crates/blake3/@ANY_VERSION@/download

## rust-blake3 1.8.2

=== debian/changelog ===
rust-blake3 (1.8.2-1) unstable; urgency=medium

  * Team upload.
  * Package blake3 1.8.2 from crates.io using debcargo 2.8.0

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Mon, 16 Feb 2026 18:14:35 +0100

rust-blake3 (1.8.1-2) experimental; urgency=medium

  * Team upload.
  * Package blake3 1.8.1 from crates.io using debcargo 2.8.0
  * Enable build of libblake3-0 / libblake3-dev (Closes: #1107091, thanks наб!)

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Sun, 15 Feb 2026 17:50:29 +0100

=== debian/control ===
--- 
+++ 
@@ -1,41 +1,41 @@
 Source: rust-blake3
 Section: rust
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
- dh-sequence-cargo
+ dh-sequence-cargo,
+ cmake
 Build-Depends-Arch: cargo:native <!nocheck>,
  rustc:native <!nocheck>,
  libstd-rust-dev <!nocheck>,
- librust-arrayref-0.3+default-dev (>= 0.3.5-~~) <!nocheck>,
- librust-arrayvec-0.7-dev (>= 0.7.4-~~) <!nocheck>,
- librust-cc-1+default-dev (>= 1.1.12-~~) <!nocheck>,
+ librust-arrayref-0.3+default-dev (>= 0.3.5) <!nocheck>,
+ librust-arrayvec-0.7-dev (>= 0.7.4) <!nocheck>,
+ librust-cc-1+default-dev (>= 1.1.12) <!nocheck>,
  librust-cfg-if-1+default-dev <!nocheck>,
- librust-constant-time-eq-0.3-dev (>= 0.3.1-~~) <!nocheck>
+ librust-constant-time-eq-0.3-dev (>= 0.3.1) <!nocheck>
 Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders:
  karthek <mail@karthek.com>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/blake3]
 Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/blake3
 Homepage: https://github.com/BLAKE3-team/BLAKE3
 X-Cargo-Crate: blake3
-Rules-Requires-Root: no
+X-Cargo-Crate-Version: 1.8.2
 
 Package: librust-blake3-dev
 Architecture: any
 Multi-Arch: same
 Depends:
  ${misc:Depends},
- librust-arrayref-0.3+default-dev (>= 0.3.5-~~),
- librust-arrayvec-0.7+zeroize-dev (>= 0.7.4-~~),
- librust-arrayvec-0.7-dev (>= 0.7.4-~~),
- librust-cc-1+default-dev (>= 1.1.12-~~),
+ librust-arrayref-0.3+default-dev (>= 0.3.5),
+ librust-arrayvec-0.7+zeroize-dev (>= 0.7.4),
+ librust-arrayvec-0.7-dev (>= 0.7.4),
+ librust-cc-1+default-dev (>= 1.1.12),
  librust-cfg-if-1+default-dev,
- librust-constant-time-eq-0.3-dev (>= 0.3.1-~~),
- librust-digest-0.10+default-dev (>= 0.10.1-~~),
- librust-digest-0.10+mac-dev (>= 0.10.1-~~),
+ librust-constant-time-eq-0.3-dev (>= 0.3.1),
+ librust-digest-0.10+default-dev (>= 0.10.1),
+ librust-digest-0.10+mac-dev (>= 0.10.1),
  librust-memmap2-0.9+default-dev,
- librust-rayon-core-1+default-dev (>= 1.12.1-~~),
+ librust-rayon-core-1+default-dev (>= 1.12.1),
  librust-serde-1+derive-dev,
  librust-zeroize-1-dev
 Provides:
@@ -92,23 +92,46 @@
  librust-blake3-1.8+traits-preview-dev (= ${binary:Version}),
  librust-blake3-1.8+wasm32-simd-dev (= ${binary:Version}),
  librust-blake3-1.8+zeroize-dev (= ${binary:Version}),
- librust-blake3-1.8.1-dev (= ${binary:Version}),
- librust-blake3-1.8.1+default-dev (= ${binary:Version}),
- librust-blake3-1.8.1+digest-dev (= ${binary:Version}),
- librust-blake3-1.8.1+mmap-dev (= ${binary:Version}),
- librust-blake3-1.8.1+neon-dev (= ${binary:Version}),
- librust-blake3-1.8.1+no-avx2-dev (= ${binary:Version}),
- librust-blake3-1.8.1+no-avx512-dev (= ${binary:Version}),
- librust-blake3-1.8.1+no-neon-dev (= ${binary:Version}),
- librust-blake3-1.8.1+no-sse2-dev (= ${binary:Version}),
- librust-blake3-1.8.1+no-sse41-dev (= ${binary:Version}),
- librust-blake3-1.8.1+prefer-intrinsics-dev (= ${binary:Version}),
- librust-blake3-1.8.1+pure-dev (= ${binary:Version}),
- librust-blake3-1.8.1+rayon-dev (= ${binary:Version}),
- librust-blake3-1.8.1+serde-dev (= ${binary:Version}),
- librust-blake3-1.8.1+std-dev (= ${binary:Version}),
- librust-blake3-1.8.1+traits-preview-dev (= ${binary:Version}),
- librust-blake3-1.8.1+wasm32-simd-dev (= ${binary:Version}),
- librust-blake3-1.8.1+zeroize-dev (= ${binary:Version})
+ librust-blake3-1.8.2-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+default-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+digest-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+mmap-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+neon-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+no-avx2-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+no-avx512-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+no-neon-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+no-sse2-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+no-sse41-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+prefer-intrinsics-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+pure-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+rayon-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+serde-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+std-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+traits-preview-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+wasm32-simd-dev (= ${binary:Version}),
+ librust-blake3-1.8.2+zeroize-dev (= ${binary:Version})
 Description: BLAKE3 hash function - Rust source code
  Source code for Debianized Rust crate "blake3"
+
+Package: libblake3-dev
+Architecture: any
+Section: libdevel
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+ libblake3-0 (=${binary:Version})
+Description: BLAKE3 hash function - C library - development files
+ BLAKE3 is a cryptographic hash function that is much faster than common
+ alternatives, while at the same time being faster and highly parallelizable.
+ This package contains the development support files.
+
+Package: libblake3-0
+Architecture: any
+Section: libs
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends}
+Description: BLAKE3 hash function - C library - shared library
+ BLAKE3 is a cryptographic hash function that is much faster than common
+ alternatives, while at the same time being faster and highly parallelizable.
+ This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f

execute_before_dh_auto_clean:
	dh_auto_clean     --sourcedirectory=c --buildsystem=cmake

execute_before_dh_auto_configure:
	dh_auto_configure --sourcedirectory=c --buildsystem=cmake -- -DBUILD_SHARED_LIBS=YES

execute_after_dh_auto_build:
	dh_auto_build     --sourcedirectory=c --buildsystem=cmake

execute_before_dh_auto_test:
	dh_auto_test      --sourcedirectory=c --buildsystem=cmake

override_dh_auto_install:
	dh_auto_install   --sourcedirectory=c --buildsystem=cmake
	dh_auto_install -N libblake3-dev -N libblake3-0

	# remove files generated by cmake's configure part above, since copying
	# of sources happens in auto_build..
	rm -rf debian/librust-blake3-dev/usr/share/cargo/registry/blake3-*.*.*/obj-*/

%:
	dh $@ --buildsystem cargo

=== debian/tests/control ===
Test-Command: /usr/share/cargo/bin/cargo-auto-test blake3 1.8.2 --all-targets --all-features
Features: test-name=rust-blake3:@
Depends: dh-cargo (>= 33~), rustc, librust-ciborium-0.2+default-dev (>= 0.2.2), librust-hex-0.4+default-dev (>= 0.4.2), librust-hmac-0.12+default-dev, librust-page-size-0.6+default-dev, librust-rand-0.8+default-dev, librust-rand-chacha-0.3+default-dev (>= 0.3.1), librust-serde-json-1+default-dev (>= 1.0.107), librust-tempfile-3+default-dev (>= 3.8.0), @
Restrictions: allow-stderr, skip-not-installable, flaky

Test-Command: /usr/share/cargo/bin/cargo-auto-test blake3 1.8.2 --all-targets
Features: test-name=librust-blake3-dev:default
Depends: dh-cargo (>= 33~), rustc, librust-ciborium-0.2+default-dev (>= 0.2.2), librust-hex-0.4+default-dev (>= 0.4.2), librust-hmac-0.12+default-dev, librust-page-size-0.6+default-dev, librust-rand-0.8+default-dev, librust-rand-chacha-0.3+default-dev (>= 0.3.1), librust-serde-json-1+default-dev (>= 1.0.107), librust-tempfile-3+default-dev (>= 3.8.0), @
Restrictions: allow-stderr, skip-not-installable

Test-Command: /usr/share/cargo/bin/cargo-auto-test blake3 1.8.2 --all-targets --no-default-features --features digest
Features: test-name=librust-blake3-dev:digest
Depends: dh-cargo (>= 33~), rustc, librust-ciborium-0.2+default-dev (>= 0.2.2), librust-hex-0.4+default-dev (>= 0.4.2), librust-hmac-0.12+default-dev, librust-page-size-0.6+default-dev, librust-rand-0.8+default-dev, librust-rand-chacha-0.3+default-dev (>= 0.3.1), librust-serde-json-1+default-dev (>= 1.0.107), librust-tempfile-3+default-dev (>= 3.8.0), @
Restrictions: allow-stderr, skip-not-installable

Test-Command: /usr/share/cargo/bin/cargo-auto-test blake3 1.8.2 --all-targets --no-default-features --features mmap
Features: test-name=librust-blake3-dev:mmap
Depends: dh-cargo (>= 33~), rustc, librust-ciborium-0.2+default-dev (>= 0.2.2), librust-hex-0.4+default-dev (>= 0.4.2), librust-hmac-0.12+default-dev, librust-page-size-0.6+default-dev, librust-rand-0.8+default-dev, librust-rand-chacha-0.3+default-dev (>= 0.3.1), librust-serde-json-1+default-dev (>= 1.0.107), librust-tempfile-3+default-dev (>= 3.8.0), @
Restrictions: allow-stderr, skip-not-installable

Test-Command: /usr/share/cargo/bin/cargo-auto-test blake3 1.8.2 --all-targets --no-default-features --features neon
Features: test-name=librust-blake3-dev:neon
Depends: dh-cargo (>= 33~), rustc, librust-ciborium-0.2+default-dev (>= 0.2.2), librust-hex-0.4+default-dev (>= 0.4.2), librust-hmac-0.12+default-dev, librust-page-size-0.6+default-dev, librust-rand-0.8+default-dev, librust-rand-chacha-0.3+default-dev (>= 0.3.1), librust-serde-json-1+default-dev (>= 1.0.107), librust-tempfile-3+default-dev (>= 3.8.0), @
Restrictions: allow-stderr, skip-not-installable, flaky

Test-Command: /usr/share/cargo/bin/cargo-auto-test blake3 1.8.2 --all-targets --no-default-features --features no_avx2
Features: test-name=librust-blake3-dev:no_avx2

=== debian/watch ===
Version: 5

Source: https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=crates.io/blake3
Matching-Pattern:  .*/crates/blake3/@ANY_VERSION@/download
Filenamemangle: s/.*\/(.*)\/download/blake3-$1\.tar\.gz/g
Uversionmangle: s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\.?\d*)$/$1~$2/
Dversionmangle: s/@DEB_EXT@//g
Compression: gzip
